;Marvin The Wireframe Aeroplane
;For Wednesday Workshop #003 - The Firework Challenge

;						And what a surprise it was!  Halfway through doing a Sim-Firework-Maker-Seller-Tycoon type thing, I suddenly realised how much fun it'd be to have "Invisible Munky" leaping around a firework display..
;						Munky's arrow was made super quickly, (and not 100% like the original!) and it bobbed along more like a paper aeroplane, than a munky!  So...  Marvin the Wireframe Aeroplane was born!

Graphics 640,480,0,2
If Upper$(Left$(CommandLine$(),4))="FULL" Then Graphics 640,480,0,1
SetBuffer BackBuffer()

HidePointer



;First, Generate Cityscape
Type cityscape
	Field x#
	Field width
	Field height
	Field col
End Type
Global building.cityscape=New cityscape
Delete building.cityscape
atx=0
For n=1 To 1000
	building.cityscape=New cityscape
	building\x#=atx
	building\width=Rand(10,50)
	building\height=Rand(40,200)
	building\col=Rand(40,100)
	atx=atx+building\width+2
Next
Global MaxWide=atx

;Then Setup Firework Type
Type rocket
Field atx#,aty#,aimx#,aimy#
Field burst
Field user
End Type

Type particle
Field centx#
Field centy#
Field angle#
Field life#
Field reach#
Field colr,colg,colb
End Type

hightime=30000

font1=LoadFont("arial",24)
SetFont font1
loopa=LoadSound("system/loopa.mp3"):LoopSound loopa:PlaySound loopa
;loopb=LoadSound("system/loopb.mp3"):LoopSound loopb:PlaySound loopb
Global pop=LoadSound("system/pop.wav")

.restart
Global started=0
gameover=0
Shots=10
Global angle#=0
Global XSpeed#=0
Global plrx#=320
Global plry#=100

Global LevelAng#=1
Global LevelSpeed#=8

Repeat
Cls
LockBuffer BackBuffer()

;movex=-1

drawcity(movex)

rockets(movex)

MunkyArrow(320,plry,angle)

Color 255,255,255
For n=1 To 10
If shots=>n Then Line n*10,470,n*10,480
Next


Color 255,255,255
Line MouseX()-4,MouseY()-4,MouseX()+4,MouseY()+4
Line MouseX()+4,MouseY()-4,MouseX()-4,MouseY()+4


UnlockBuffer BackBuffer()

If started=0
shots=10

Color 255,180,180:Text 320,200,"Marvin The Wireframe Aeroplane",1,1
Color 255,255,255:Text 320,240,"In",1,1
Color 180,180,255:Text 320,280,"Fourth of July Firework Madness",1,1

starttime=MilliSecs():targettime=MilliSecs()+10000:extratime=MilliSecs()+2000
EndIf

If MilliSecs()>extratime Then extratime=extratime+2000:If shots<10 Then shots=shots+1
If MilliSecs()>targettime Then levelang=levelang+0.1:levelspeed=levelspeed-0.1:targettime=targettime+10000


If started=1
wplrx=plrx
plrx=plrx+(Sin(angle)*XSpeed)
plry=plry-(Cos(angle)*2)
If angle>180 Then angle=angle-LevelAng
If angle<180 Then angle=angle+LevelAng

movex=plrx-wplrx


If plry>480 Then gameover=1
EndIf



If Rand(0,10)=1
a.rocket=New rocket
a\user=0
a\atx=Rand(0,640)
a\aty=480
a\aimx=a\atx+Rand(-30,30)
a\aimy=Rand(200,400)
a\burst=0
EndIf


If MouseDown(1) And mudown=0 And shots>0
shots=shots-1
mudown=1
a.rocket=New rocket
a\user=1
a\atx=Rand(0,640)
a\aty=480
a\aimx=MouseX()
a\aimy=MouseY()
a\burst=0
EndIf
If MouseDown(1)=0 Then mudown=0

;If started=1
Color 0,255,0
Text 320,460,showtime$(MilliSecs()-starttime),1,1
thistime=MilliSecs()-starttime
Color 255,0,0
If thistime>hightime Then Color 0,255,0
Text 320,15,showtime$(hightime),1,1
;EndIf

If KeyDown(1) Then gameover=9
Flip
Until gameover<>0

If gameover=9 Then End

Color 255,255,255
Text 320,240,"Game Over",1,1
thistime=MilliSecs()-starttime
If thistime>hightime Then hightime=thistime:Text 320,340,"New Hiscore!",1,1

For a.rocket=Each rocket
Delete a.rocket
Next
For b.particle=Each particle
Delete b.particle
Next

Flip
Delay 2500
Goto restart




Function showtime$(mills)
out$=""
mills=mills/1000
out$=out$+Right$("00"+(mills/60),2)
out=out+":"
out$=out$+Right$("00"+(mills Mod 60),2)
Return out
End Function

Function MunkyArrow(cenx,ceny,anglego)
Color 255,0,0
Line cenx,ceny,cenx+(Sin(anglego-10)*10),ceny+(Cos(anglego-10)*10)
Line cenx,ceny,cenx+(Sin(anglego+10)*10),ceny+(Cos(anglego+10)*10)
End Function


Function rockets(scrx#)
For a.rocket=Each rocket
a\atx=a\atx+scrx
a\aimx=a\aimx+scrx
If a\burst=0
	wx=a\atx
	wy=a\aty

	a\atx=a\atx+((a\aimx-a\atx)/8)
	a\aty=a\aty+((a\aimy-a\aty)/8)
	Color 255,255,255:If a\user=0 Then Color 80,80,80
	Line wx,wy,a\atx,a\aty
	
		If Abs(a\atx-a\aimx)<6 And Abs(a\aty-a\aimy)<6
		r=Rand(0,2)*125
		g=Rand(0,2)*125
		h=Rand(0,2)*125
		
		If a\user=0
		r=Rand(0,4)*25
		g=Rand(0,4)*25
		h=Rand(0,4)*25
		EndIf
		
		reach#=Rand(10,50)
		If a\user=1 Then SoundPitch pop,Rand(21000,23000):SoundVolume pop,reach/50:PlaySound pop
			For n=1 To 50
			b.particle=New particle
			b\centx=a\atx
			b\centy=a\aty
			b\angle=Rand(0,360)
			b\life=1
			b\reach=reach
			b\colr=r
			b\colg=g
			b\colb=h
			Next
		a\burst=1
		EndIf
EndIf

If a\burst>0
a\burst=a\burst+1

Color 255-(a\burst*10),255-(a\burst*10),255-(a\burst*10)

For n=0 To 36
dx=a\atx+(Sin(n*10)*(a\burst*2))
dy=a\aty+(Cos(n*10)*(a\burst*2))

If n>0
;Line wx,wy,dx,dy

EndIf

If Abs(a\atx-320)<30 And Abs(a\aty-plry)<30 And a\user=1
started=1
XSpeed=(a\atx-320)/LevelSpeed
angle=0
If xspeed>0 Then angle=20
If xspeed<0 Then angle=340:xspeed=0-xspeed
EndIf

wx=dx
wy=dy

Next


If a\burst=25 Then Delete a.rocket
EndIf


Next


For b.particle=Each particle
	b\centx=b\centx+scrx
	atx=b\centx+(Sin(b\angle)*((b\reach*b\life)/25))
	aty=b\centy-(Cos(b\angle)*((b\reach*b\life)/25))
	
	b\life=b\life+Rnd(0,1.5)
	If b\angle>180 Then b\angle=b\angle-Rnd(0,1)
	If b\angle<180 Then b\angle=b\angle+Rnd(0,1)
	
	wx=b\centx+(Sin(b\angle)*((b\reach*b\life)/25))
	wy=b\centy-(Cos(b\angle)*((b\reach*b\life)/25))

drkr=b\colr-((b\life))
If drkr<0 Then drkr=0
drkg=b\colg-((b\life))
If drkg<0 Then drkg=0
drkb=b\colb-((b\life))
If drkb<0 Then drkb=0

Color drkr,drkg,drkb
Line atx,aty,wx,wy


	If b\life>20 And Rand(1,40)=1 Then Delete b.particle
Next

End Function


Function drawcity(scrx#)
For building.cityscape=Each cityscape
building\x=building\x+scrx
If building\x<0-640 Then building\x=building\x+MaxWide
If building\x>(0-640)+MaxWide Then building\x=building\x-MaxWide

	If building\x+building\width>0 And building\x<640
	Color building\col,building\col,building\col
		Line building\x,480,building\x,480-building\height
		Line building\x,480-building\height,building\x+building\width,480-building\height
		Line building\x+building\width,480,building\x+building\width,480-building\height
	EndIf

Next
End Function